import java.util.*;
import controlP5.*;

// GUI Drawings
ControlP5 cp5;

// Result of search keywords
color background = color(30);
color foreground = color(225);

// Dropdown select function
void dropdown(int n) {
  ///* request the selected item based on index n */
  cp5.get(Textfield.class, "input").setText(
    (String)cp5.get(ScrollableList.class, "dropdown").getItem(n).get("name"));
  
  String l = (String)cp5.get(ScrollableList.class, "dropdown").getItem(n).get("value");  
  
  CColor c = new CColor();
  c.setBackground(background);
  c.setForeground(foreground);
  cp5.get(ScrollableList.class, "dropdown").getItem(n).put("color", c);
  link("https://www.reddit.com/"+l);
}

void bang() {
  autoRotate = !autoRotate;
}

void initCp5Gui() {
  cp5.addBang("bang")
       .setPosition(width-60-150, 15)
       .setSize(30, 30)
       .setColorActive(color(background, 200))
       .setColorBackground(color(background, 200))
       .setColorForeground(foreground)
       .setColorCaptionLabel(foreground)
       .setCaptionLabel("Toggle Rotation")
       .getCaptionLabel().alignX(ControlP5.CENTER);
       
  Textfield t = cp5.addTextfield("input")
    .setPosition(width-15-150, 15)
    .setSize(150, 30)
    .setCaptionLabel("Input (RegEx inc.)")
    .setColor(background)
    .setColorActive(color(foreground))
    .setColorBackground(color(foreground, 200))
    .setColorForeground(background)
    .setColorCaptionLabel(foreground)
    .setColorCursor(background);
    
  Label l = t.getCaptionLabel()
              .alignX(ControlP5.CENTER);
    
  cp5.addScrollableList("dropdown")
     .setPosition(width-15-150, 60)
     .setSize(150, height-100)
     .setBarHeight(20)
     .setItemHeight(20)
     .setFont(createFont("SansSerif", 10))
     .setType(ControlP5.LIST)
     .setColorActive(color(foreground))
     .setColorBackground(color(foreground, 200))
     .setColorForeground(background)
     .setColorCaptionLabel(foreground)
     .setColorValue(background)
     .getCaptionLabel().setVisible(false);
  
  // so that manually draw on GUI 
  cp5.setAutoDraw(false);
}

void drawGUI(){
  cam.beginHUD();
  textSize(10);
  textAlign(RIGHT, BOTTOM);
  text("MERT TOKA || MAT259 - DATA VISUALIZATION (WINTER 2017)", width-15, height-15);
  textAlign(LEFT, TOP);  
  text("SUB-REDDIT IMAGE DATA\nBETWEEN JUL 2008 - JAN 2013", 15, 15);
  
  cp5.draw();
  cam.endHUD();
}