
PShape p, p2, p3;
int selectedSubreddit = 0;

void initShapes(){
  p = createShape();
  p2 = createShape();
  p3 = createShape();

  p.beginShape(POINTS);
  p2.beginShape(LINES);
  int i = 0;
  for(Subreddit s: subredditMap.values()){
    int j = 0;
    for(User u: s.users.values()){
      for(int k = 0;  k < u.images.get(s.name).size(); k++)
      {
        Image im = u.images.get(s.name).get(k);
        float x = cos(i * TWO_PI/subredditMap.size())
                      * logmap(j, 0, globalMaxNumberUsers, 1990, 110);
        float y = sin(i * TWO_PI/subredditMap.size())
                      * logmap(j, 0, globalMaxNumberUsers, 1990, 110);
        float z = map(k, 0, globalMaxImagePerUser, 0, 2000) * 4;
        p.strokeWeight(3);
        p.stroke(255, 255, 255, 150);
        p.vertex(x,y,z);
      }
      p2.stroke(255, logmap(s.users.size(), 0, globalMaxNumberUsers, 0, 255));
      for(int l = 2010; l > 400; l /= 10){
        float logm = logmap(l, 1, 2000, 0, 2000);
        p2.vertex(cos(i * TWO_PI/subredditMap.size())*logm,
        sin(i * TWO_PI/subredditMap.size())*logm,
        -5.);
        p2.vertex(cos(i * TWO_PI/subredditMap.size())*(logm+100),
        sin(i * TWO_PI/subredditMap.size())*(logm+100),
        -5.);
      }
      j++;
    }
    if(i%10==0){
      p2.stroke(255, 20);
    }
    else{
      p2.stroke(255, 10);
    }
    p2.vertex(cos(i * TWO_PI/subredditMap.size())*110,
              sin(i * TWO_PI/subredditMap.size())*110,
              -5.);
    p2.vertex(cos(i * TWO_PI/subredditMap.size())*2110,
              sin(i * TWO_PI/subredditMap.size())*2110,
              -5.);
    i++;
  }
  p2.endShape();
  p.endShape();
}

void drawTitles(){
  // Draw titles
  fill (255);
  int i = 0;
  for(Subreddit s: subredditMap.values()){    
    if(s.users.size() > globalMaxNumberUsers/2000.){
      float angle = map(i, 0, subredditMap.size(), 0, TWO_PI);
      textSize(40);
      textAlign(LEFT, CENTER);
      pushMatrix();
      translate(cos(angle)*2150,
                sin(angle)*2150);

      if(angle > HALF_PI && angle < 3*HALF_PI){
        textAlign(RIGHT, CENTER);
        rotateZ(PI+angle);
      }
      else{
        textAlign(LEFT, CENTER);
        rotateZ(angle);
      }
      text(s.name, 0, 0);
      popMatrix();
    }
    i++;
  }
  noFill();
  stroke(255, 70);
  ellipse(0,0,220,220);
}

void drawShapes(){
  shape(p2);
  if(mousePicked){
    shape(p3);
  }
  else if(cp5.get(Textfield.class, "input").getText().length() <= 1){
    cp5.get(ScrollableList.class, "dropdown").hide();
    shape(p);
  }
  else{
    shape(p3);
  }
}

void buildShapeOnKeyPress(){
  cp5.get(ScrollableList.class, "dropdown").clear();
      
  p3 = createShape();
  p3.beginShape(POINTS);
  int i = 0;
  for(Subreddit s: subredditMap.values()){
    int j = 0;
    for(User u: s.users.values()){
      for(int k = 0;  k < u.images.get(s.name).size(); k++)
      {
        Image im = u.images.get(s.name).get(k);
        float x = cos(i * TWO_PI/subredditMap.size())
                      * logmap(j, 0, globalMaxNumberUsers, 1990, 110);
        float y = sin(i * TWO_PI/subredditMap.size())
                      * logmap(j, 0, globalMaxNumberUsers, 1990, 110);
        float z = map(k, 0, globalMaxImagePerUser, 0, 2000) * 4;
        
        if(match(im.title, textValue) != null){
          cp5.get(ScrollableList.class, "dropdown").show();
          fill(foreground);
          cp5.get(ScrollableList.class, "dropdown").addItem(im.title, im.postURL);
        
          p3.strokeWeight(5);
          p3.stroke(255, 255, 0, 150);                
        }
        else
        {
          p3.strokeWeight(2);
          p3.stroke(255, 30);                
        
        }
        p3.vertex(x,y,z);
      }
      j++;
    }
    i++;
  }
  p3.endShape();
}

void buildShapeOnMousePress(){
  if(mouseButton == RIGHT){
    mousePicked = true;
    p3 = createShape();
    p3.beginShape(POINTS);
    
    cp5.get(ScrollableList.class, "dropdown").clear();
    int i = 0;
    for(Subreddit s: subredditMap.values()){
        int j = 0;
        for(User u: s.users.values()){
          for(int k = 0;  k < u.images.get(s.name).size(); k++)
          {
            Image im = u.images.get(s.name).get(k);
            float x = cos(i * TWO_PI/subredditMap.size())
                          * logmap(j, 0, globalMaxNumberUsers, 1990, 110);
            float y = sin(i * TWO_PI/subredditMap.size())
                          * logmap(j, 0, globalMaxNumberUsers, 1990, 110);
            float z = map(k, 0, globalMaxImagePerUser, 0, 2000) * 4;
            
            if(selectedSubreddit > i-3 && selectedSubreddit < i+3){
                  cp5.get(ScrollableList.class, "dropdown").show();
                  fill(foreground);
                  cp5.get(ScrollableList.class, "dropdown").addItem(im.title, im.postURL);
                
                  p3.strokeWeight(5);
                  p3.stroke(200, 255, 0, 150);              
            }
            else
            {
              p3.strokeWeight(2);
              p3.stroke(255, 150);    
            }
            p3.vertex(x,y,z);
          
          }
          j++;
      }
      i++;
    }
    p3.endShape();
  }
}