int globalMaxImageID = 0;
int globalMinImageID = MAX_INT;
int globalMaxUpVotes = 0 ;
int globalMaxDownVotes = 0 ;
float globalMaxNumberComments = 0;
int globalMaxScore = 0;
int globalMinScore = MAX_INT;
int globalMaxNumOccurance = 0;
long globalMaxUnixtime = 0;
long globalMinUnixtime = MAX_INT;

float globalMaxNumberUsers = 0;
float globalMaxImagePerUser = 0;


HashMap<String, Subreddit> subredditMap;

class Subreddit{
  String name;
  HashMap<String, User> users;
  ArrayList<Image> images;

  Subreddit(String _s){
    name = _s;
    users = new HashMap<String, User>();
    images = new ArrayList<Image>();
  }
  void addUser(User _u){
    if(!users.containsKey(_u.username)){
      users.put(_u.username, _u);
      globalMaxNumberUsers = max(globalMaxNumberUsers, users.size());
    }
  }
  void addImage(Image _i){
    images.add(_i);
  }
}

class User{
  String username;

  // subreddit - image map
  HashMap<String, ArrayList<Image>> images;

  User(String _u){
    username = _u;
    images = new HashMap<String, ArrayList<Image>>();
  }
  void putMap(String _s, Image _i){
    if(images.get(_s) == null)
    {
      ArrayList<Image> tempArr = new ArrayList<Image>();
      tempArr.add(_i);
      images.put(_s, tempArr);
      
      return;
    }
    
    boolean flag = false;
    for(int k = 0; k < images.get(_s).size(); k++){
      Image im = images.get(_s).get(k);
      if(im.id == _i.id)
      {
        flag = true;
        
        break;
      }
    }
    if(!flag){
      images.get(_s).add(_i);
      if(images.get(_s).size() == 1760)
        println(_s, "/"+username+"\\");
      globalMaxImagePerUser = max(globalMaxImagePerUser, images.get(_s).size());
    }
  }
}

class Image{
  int id;
  int upVotes;
  int downVotes;
  int numberComments;
  int score;
  int numOcc;

  long unixtime;

  String title;
  String postURL;

  User owner;
  Subreddit host;

  Image(int _id, int _uv, int _dv, int _s, int _nc, long _t, String _n, String _p, int _num){
    id=_id;
    upVotes = _uv;
    downVotes = _dv;
    score = _s;
    numberComments = _nc;
    unixtime = _t;
    title = _n;
    postURL = _p;
    numOcc = _num;

    globalMaxImageID = max(globalMaxImageID, _id);
    globalMinImageID = min(globalMinImageID, _id);
    globalMaxUpVotes = max(globalMaxUpVotes, _uv);
    globalMaxDownVotes = max( globalMaxDownVotes , _dv);
    globalMaxNumberComments = max(globalMaxNumberComments, _nc);
    globalMaxScore = max(globalMaxScore, _s);
    globalMinScore = min(globalMinScore, _s);
    globalMaxNumOccurance = max(globalMaxNumOccurance, _num); 
    globalMaxUnixtime = globalMaxUnixtime > _t ? globalMaxUnixtime : _t;
    globalMinUnixtime = globalMinUnixtime < _t ? globalMinUnixtime : _t;
  }

  void assignProperties(User _u, Subreddit _s){
    owner = _u;
    host = _s;
  }
}