// MAT259 Final Project (Winter 2017)
// Author: Mert Toka
//         (merttoka [a t] mat.ucsb.edu)
// Definition: Reddit image data visualization
//             The 

import peasy.*;
import peasy.org.apache.commons.math.*;
import peasy.org.apache.commons.math.geometry.*;

PeasyCam cam;

String textValue = "";

boolean mousePicked = false;
boolean autoRotate = false;

Selection_in_P3D_OPENGL_A3D select;

void setup(){
  //size(1100, 900, P3D);
  fullScreen(P3D);

  cp5 = new ControlP5(this);
  initCp5Gui();

  cam = new PeasyCam(this, 2500);

  select = new Selection_in_P3D_OPENGL_A3D();

  parseData();

  initShapes();

  println(new Date(globalMinUnixtime*1000), new Date(globalMaxUnixtime*1000));
}
float angle = 0;
void draw(){
  background(30);
  select.captureViewMatrix((PGraphics3D)g);
  if(autoRotate)
    angle+=PI*0.0005;
  rotateZ(angle);
  
  // onMouseHover
  if(select.calculatePickPoints(mouseX, (int)map(mouseY, 0, height, height, 0))){
    PVector p = new PVector();
    boolean flag = planeRayCollision(select.ptStartPos, select.ptEndPos, p);
    if(flag){
      float alpha = atan2(p.y,p.x) < 0 ? TWO_PI+atan2(p.y,p.x): atan2(p.y,p.x);
      float r = sqrt(p.x*p.x+p.y*p.y);
      
      selectedSubreddit = int((alpha) * subredditMap.size()/TWO_PI);
      
      stroke(255, 200, 200, 150);
      line(cos(alpha)*1990, sin(alpha)*1990,0, cos(alpha)*110, sin(alpha)*110, 0);
    }
  }

  drawTitles();
  drawShapes();
  
  drawGUI();
}

void mousePressed(){
  buildShapeOnMousePress();
}

void keyPressed(KeyEvent e){
  if (e.isControlDown() && e.getKey() == 16) {//ctrl+p
    save(year()+"-"+month()+"-"+day()+" "+
      hour()+"_"+minute()+"_"+second()+".png");
  }
  
  if(key == '`'){
    mousePicked = false;
    cp5.get(Textfield.class, "input").setFocus(false);
    cp5.get(Textfield.class, "input").setText("");
  }
  else if((key >= 'a' && key <= 'z') || keyCode == BACKSPACE || key == ' '){
    mousePicked = false;
    cp5.get(Textfield.class, "input").setFocus(true);
    
    textValue = cp5.get(Textfield.class, "input").getText();
  
    if(textValue.length() > 1 ){
      buildShapeOnKeyPress();
    }
  }
  else if(key=='1'){
    println("pos", cam.getPosition()[0], cam.getPosition()[1], cam.getPosition()[2]);
    println("rot", cam.getRotations()[0], cam.getRotations()[1], cam.getRotations()[2]);
    
  }
}

////////// MATH
float logmap(float v, float istart, float istop, float ostart, float ostop){
  float result = 0;
  try{
    result = map(log(v), log(max(1,istart)), log(istop), ostart, ostop);
  }catch(Exception e) {/*e.printStackTrace();*/ }
  return result;
}